ifeq (${CROSS_COMPILER},yes)
	IA-32_TARGET=i686-pc-linux-gnu

	IA-32_CC_DIR=/usr/local/i686/bin
	IA-32_BINUTILS_DIR=/usr/local/i686/bin

	CC=$(IA-32_CC_DIR)/$(IA-32_TARGET)-gcc
	AS=$(IA-32_BINUTILS_DIR)/$(IA-32_TARGET)-as
	LD=$(IA-32_BINUTILS_DIR)/$(IA-32_TARGET)-ld
	OBJCOPY=$(IA-32_BINUTILS_DIR)/$(IA-32_TARGET)-objcopy
	OBJDUMP=$(IA-32_BINUTILS_DIR)/$(IA-32_TARGET)-objdump
else
	CC=gcc
	AS=as
	LD=ld
	OBJCOPY=objcopy
	OBJDUMP=objdump
endif

BFD_NAME=elf32-i386
BFD_ARCH=i386

DEFS:=-DARCH=$(ARCH) -DFPU_LAZY

ifdef SMP
DEFS+=-D$(SMP)
endif

ifdef HT
DEFS+=-D$(HT)
endif

CPPFLAGS=$(DEFS) -nostdinc -I../include
CFLAGS=$(CPPFLAGS) -nostdlib -fno-builtin -fomit-frame-pointer -Werror-implicit-function-declaration -Wmissing-prototypes -Werror -O3
LFLAGS=-M

../arch/$(ARCH)/_link.ld: ../arch/$(ARCH)/_link.ld.in
	$(CC) $(CFLAGS) -E -x c $< | grep -v "^\#" > $@

arch_sources= \
	arch/context.s \
	arch/debug/panic.s \
	arch/cpuid.s \
	arch/delay.s \
	arch/asm.S \
	arch/proc/scheduler.c \
	arch/acpi/acpi.c \
	arch/acpi/madt.c \
	arch/bios/bios.c \
	arch/smp/ap.S \
	arch/smp/apic.c \
	arch/smp/mps.c \
	arch/smp/smp.c \
	arch/atomic.S \
	arch/smp/ipi.c \
	arch/ia32.c \
	arch/interrupt.c \
	arch/pm.c \
	arch/userspace.c \
	arch/cpu/cpu.c \
	arch/mm/frame.c \
	arch/mm/memory_init.c \
	arch/mm/page.c \
	arch/mm/tlb.c \
	arch/drivers/i8042.c \
	arch/drivers/i8254.c \
	arch/drivers/i8259.c \
	arch/drivers/ega.c \
	arch/boot/boot.S \
	arch/boot/memmap.S\
	arch/fpu_context.c\
	arch/fmath.c
